Sponsored Content
Top Forums UNIX for Advanced & Expert Users how to have a cp progress bar? Post 302197445 by era on Wednesday 21st of May 2008 02:56:23 AM
Old 05-21-2008
Here's a quick hack. If you don't have awk or stat available, I don't imagine you will have Perl, either.

Code:
#!/bin/sh
#
# cpbar -- era 2008-05-21 for unix.com
#
# Depends:
#  stat
#  cp
#  awk

syntax () {
    echo "Syntax: $0 srcfile destfile" >&2
    echo " " "$@" >&2
    exit 1
}

test -r "$1" || syntax "File '$1' not found"
test -d "$2" && syntax "Must name destination file ('$2' is a directory)"

size=`stat -c %s "$1"`

cp "$1" "$2" &
cppid=$!

trap 'echo; kill $cppid; rm -f "$2"; exit 127' 1 2 3 5 15

while true; do
    nsize=`stat -c %s "$2"`
    awk -v f1="$1" -v f2="$2" -v size=$size -v nsize=$nsize '
	BEGIN { printf "Copying %s to %s: %4.2f%%\r", f1, f2, 100*nsize/size }'
    case $nsize in $size) break ;; esac
    sleep 1
done

echo

wait $cppid


Last edited by era; 05-21-2008 at 04:00 AM.. Reason: Remove destination file if interrupted; percentage calculation wrong (duh :-); put break after awk so it prints 100% at end
 

9 More Discussions You Might Find Interesting

1. Shell Programming and Scripting

progress bar

i am trying to write a script where in it will connect to remote servers and execute remote scripts to fetch some data and ftp it back to a main server. i would like to add a script where it will show some sort of status bar until such time that the expected files have been recieved. something... (3 Replies)
Discussion started by: inquirer
3 Replies

2. UNIX for Advanced & Expert Users

progress bar

Hi all, I want to print # like that in a progress bar.. For e.g We can notice that during installation ... but,how to do that? Thnx, sakthi. (4 Replies)
Discussion started by: sakthi.abdullah
4 Replies

3. Shell Programming and Scripting

Progress bar

Hi friends, how can I show a progress bar for any running process in the shell script. For example when I am copying or compressing a file. Thanks. (1 Reply)
Discussion started by: dwiravi
1 Replies

4. Shell Programming and Scripting

progress bar

hi all, in shell script (ksh), how do i write a progress bar ?? i have a script which searches files and while its searching i am currently printing out "." and if it finds what its searching for the script prints out the name of the file e.g .................. firstFile.txt... (2 Replies)
Discussion started by: cesarNZ
2 Replies

5. Programming

A progress bar in C

Hello, it's me again...:eek: I need to create a progress bar in C, but i have no idea on how to do it. i want it to output something like this: Progress: 58% But i can't get it to work. Could you please post an example progress bar written in ANSI C? Thanks (4 Replies)
Discussion started by: Zykl0n-B
4 Replies

6. Shell Programming and Scripting

Progress bar for cp

I'm trying to use this code to get a progress bar for cp: "Can you get cp to give a progress bar like wget?" But I'm getting these errors: stat: illegal option -- c usage: stat awk: division by zero input record number 1, file source line number 4 I'm using Mac OS X 10.6... (1 Reply)
Discussion started by: pcwiz
1 Replies

7. Programming

C progress bar issues

-First- Hi guys im trying to create a small C app that'll run PING/NETSTAT and such and generate a report... I want to create a progress bar so I figure since I was gonna use multiple commands I was better of to create a function and call the bar when needed to print on the command line My... (7 Replies)
Discussion started by: Jess83
7 Replies

8. Shell Programming and Scripting

Perl Progress BAR

Looking for a solution to why my progress bar not working My code print "STARTED:\n "; my $pdf = CAM::PDF->new('XYZ.pdf') or die $CAM::PDF::errstr; print STDOUT "Processing File: "; open (FILE, ">bill_data.txt") || die "Unable to save Bill_data.txt file"; for my $pagenum (1 ..... (4 Replies)
Discussion started by: chakrapani
4 Replies

9. Shell Programming and Scripting

Progress bar

Hi Experts; Im in the process of writing a shell script for enabling an IT operations to run archiving.We use netbackup. The script is complete, though there is one bit that i need help on. Im trying to have a progess bar for the procedure.I have gone through the man page of the command in... (5 Replies)
Discussion started by: maverick_here
5 Replies
MALLOC(3)						   BSD Library Functions Manual 						 MALLOC(3)

NAME
malloc, calloc, realloc, free -- general purpose memory allocation functions LIBRARY
Standard C Library (libc, -lc) SYNOPSIS
#include <stdlib.h> void * malloc(size_t size); void * calloc(size_t number, size_t size); void * realloc(void *ptr, size_t size); void free(void *ptr); DESCRIPTION
The malloc() function allocates size bytes of uninitialized memory. The allocated space is suitably aligned (after possible pointer coer- cion) for storage of any type of object. The calloc() function allocates space for number objects, each size bytes in length. The result is identical to calling malloc() with an argument of ``number * size'', with the exception that the allocated memory is explicitly initialized to zero bytes. The realloc() function changes the size of the previously allocated memory referenced by ptr to size bytes. The contents of the memory are unchanged up to the lesser of the new and old sizes. If the new size is larger, the value of the newly allocated portion of the memory is undefined. Upon success, the memory referenced by ptr is freed and a pointer to the newly allocated memory is returned. Note that realloc() may move the memory allocation, resulting in a different return value than ptr. If ptr is NULL, the realloc() function behaves identically to malloc() for the specified size. The free() function causes the allocated memory referenced by ptr to be made available for future allocations. If ptr is NULL, no action occurs. RETURN VALUES
The malloc() and calloc() functions return a pointer to the allocated memory if successful; otherwise a NULL pointer is returned and errno is set to ENOMEM. The realloc() function returns a pointer, possibly identical to ptr, to the allocated memory if successful; otherwise a NULL pointer is returned, and errno is set to ENOMEM if the error was the result of an allocation failure. The realloc() function always leaves the original buffer intact when an error occurs. The free() function returns no value. EXAMPLES
When using malloc(), be careful to avoid the following idiom: if ((p = malloc(number * size)) == NULL) err(EXIT_FAILURE, "malloc"); The multiplication may lead to an integer overflow. To avoid this, calloc() is recommended. If malloc() must be used, be sure to test for overflow: if (size && number > SIZE_MAX / size) { errno = EOVERFLOW; err(EXIT_FAILURE, "allocation"); } When using realloc(), one must be careful to avoid the following idiom: nsize += 50; if ((p = realloc(p, nsize)) == NULL) return NULL; Do not adjust the variable describing how much memory has been allocated until it is known that the allocation has been successful. This can cause aberrant program behavior if the incorrect size value is used. In most cases, the above example will also leak memory. As stated ear- lier, a return value of NULL indicates that the old object still remains allocated. Better code looks like this: newsize = size + 50; if ((p2 = realloc(p, newsize)) == NULL) { if (p != NULL) free(p); p = NULL; return NULL; } p = p2; size = newsize; SEE ALSO
madvise(2), mmap(2), sbrk(2), alloca(3), atexit(3), getpagesize(3), memory(3), posix_memalign(3) For the implementation details, see jemalloc(3). STANDARDS
The malloc(), calloc(), realloc() and free() functions conform to ISO/IEC 9899:1990 (``ISO C90''). BSD
May 3, 2010 BSD
All times are GMT -4. The time now is 12:16 AM.
Unix & Linux Forums Content Copyright 1993-2022. All Rights Reserved.
Privacy Policy